function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
//@ts-nocheck
import { DownloadOutlined } from '@ant-design/icons';
import { SheetComponent } from '@antv/s2-react';
import '@antv/s2-react/dist/style.min.css';
import { Tooltip } from 'antd';
import { isEqual } from 'lodash';
import React, { Component } from 'react';
import { exportCSV, formatFileName } from '../utils/csv';
import './index.less';
import $i18n from '../i18n';
var getConfig = function getConfig(data, clusterTitle, properties) {
  var _a;
  var resData = [];
  (_a = data === null || data === void 0 ? void 0 : data.nodes) === null || _a === void 0 ? void 0 : _a.forEach(function (node) {
    var _a;
    resData.push(Object.assign(Object.assign(Object.assign({}, node.properties || {}), {
      propertyId: (_a = node.properties) === null || _a === void 0 ? void 0 : _a.id
    }), node));
  });
  resData.sort(function (a, b) {
    return Number(a.clusterId) - Number(b.clusterId);
  });
  var dataCfg = {
    fields: {
      rows: ['clusterId', 'id'],
      values: properties || ['nodeType', 'label']
    },
    meta: [{
      field: 'clusterId',
      name: clusterTitle
    }, {
      field: 'id',
      name: 'id'
    }],
    data: resData || []
  };
  return {
    dataCfg: dataCfg,
    resData: resData,
    properties: properties
  };
};
var ClustersTable = /*#__PURE__*/function (_Component) {
  function ClustersTable() {
    var _this;
    _classCallCheck(this, ClustersTable);
    _this = _callSuper(this, ClustersTable, arguments);
    // 交叉表配置项准备
    _this.options = {
      width: 500,
      height: 400,
      hierarchyType: 'grid',
      showDefaultHeaderActionIcon: false,
      style: {
        layoutWidthType: 'compact'
      }
    };
    _this.state = {
      data: null,
      config: null
    };
    _this.download = function () {
      var _this$state$config = _this.state.config,
        _this$state$config2 = _this$state$config === void 0 ? {} : _this$state$config,
        resData = _this$state$config2.resData,
        properties = _this$state$config2.properties;
      var clusterTitle = _this.props.clusterTitle;
      var fileName = formatFileName('cluster_result');
      exportCSV({
        data: resData,
        title: [clusterTitle, $i18n.get({
          id: 'gi-assets-algorithm.src.ClusterTable.NodeName',
          dm: '节点名称'
        })].concat(properties),
        titleForKey: ['clusterId', 'label'].concat(properties)
      }, fileName);
    };
    _this.onRowCellClick = function (_ref) {
      var viewMeta = _ref.viewMeta;
      var query = viewMeta.query,
        spreadsheet = viewMeta.spreadsheet;
      var rowData = spreadsheet.dataSet.getMultiData(query);
      var _ref2 = (rowData === null || rowData === void 0 ? void 0 : rowData[0]) || {},
        id = _ref2.id,
        clusterId = _ref2.clusterId;
      var focusNodeAndHighlightHull = _this.props.focusNodeAndHighlightHull;
      if (focusNodeAndHighlightHull) {
        focusNodeAndHighlightHull(id, clusterId);
      }
    };
    return _this;
  }
  _inherits(ClustersTable, _Component);
  return _createClass(ClustersTable, [{
    key: "render",
    value: function render() {
      var _this$state$config3 = this.state.config,
        _this$state$config4 = _this$state$config3 === void 0 ? {} : _this$state$config3,
        dataCfg = _this$state$config4.dataCfg;
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Tooltip, {
        title: $i18n.get({
          id: 'gi-assets-algorithm.src.ClusterTable.DownloadCsv',
          dm: '下载 CSV'
        }),
        placement: "topRight"
      }, /*#__PURE__*/React.createElement(DownloadOutlined, {
        style: {
          float: 'right'
        },
        onClick: this.download
      })), /*#__PURE__*/React.createElement("div", {
        className: "community-cluster-table-wrapper"
      }, /*#__PURE__*/React.createElement(SheetComponent, {
        sheetType: "base",
        dataCfg: dataCfg,
        options: this.options || {},
        onRowCellClick: this.onRowCellClick
      })));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var nextData = nextProps.data,
        clusterTitle = nextProps.clusterTitle,
        properties = nextProps.properties;
      var data = prevState.data;
      if (!isEqual(nextData, data)) {
        var config = getConfig(nextData, clusterTitle, properties);
        return {
          data: data,
          config: config
        };
      }
      return null;
    }
  }]);
}(Component);
export { ClustersTable as default };