function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
// @ts-nocheck
import { useContext } from '@antv/gi-sdk';
import { DownloadOutlined } from '@ant-design/icons';
import { Table, Tooltip } from 'antd';
import React, { useEffect, useState } from 'react';
import { exportCSV, formatFileName } from '../utils/csv';
import $i18n from '../i18n';
var ClustersResultTable = function ClustersResultTable(_ref) {
  var similarNodes = _ref.similarNodes,
    _ref$similarityKey = _ref.similarityKey,
    similarityKey = _ref$similarityKey === void 0 ? 'similarity' : _ref$similarityKey,
    topReset = _ref.topReset;
  var _useContext = useContext(),
    graph = _useContext.graph;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    sortOrder = _useState2[0],
    setSortOrder = _useState2[1];
  useEffect(function () {
    setSortOrder(false);
  }, [topReset]);
  var formatSimilar = function formatSimilar(value) {
    return Number("".concat(value).slice(0, 7));
  };
  var propertiesKeys = [];
  var resData = [];
  similarNodes === null || similarNodes === void 0 ? void 0 : similarNodes.forEach(function (node, index) {
    if (!node.properties) {
      return;
    }
    propertiesKeys.push('id');
    propertiesKeys = propertiesKeys.concat(Object.keys(node.properties));
    resData.push(Object.assign(Object.assign({}, node.properties), {
      index: index,
      label: node.label,
      similarity: node[similarityKey] ? formatSimilar(node[similarityKey]) : '-',
      id: node.id
    }));
  });
  propertiesKeys = Array.from(new Set(propertiesKeys));
  var columns = [{
    title: $i18n.get({
      id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.SerialNumber',
      dm: '序号'
    }),
    dataIndex: 'index',
    key: 'index',
    width: 60,
    fixed: 'left'
  }, {
    title: $i18n.get({
      id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.NodeName',
      dm: '节点名称'
    }),
    dataIndex: 'label',
    key: 'label',
    textWrap: 'word-break',
    ellipsis: true,
    fixed: 'left',
    width: 100
  }, {
    title: $i18n.get({
      id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.NodeId',
      dm: '节点 ID'
    }),
    dataIndex: 'id',
    key: 'id',
    textWrap: 'word-break',
    ellipsis: true,
    // fixed: 'left',
    width: 100
  }, {
    title: $i18n.get({
      id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.CosineSimilarity',
      dm: '余弦相似度'
    }),
    dataIndex: 'similarity',
    key: 'similarity',
    textWrap: 'word-break',
    // fixed: 'left',
    width: 120,
    sortOrder: sortOrder,
    sorter: function sorter(a, b) {
      return a.similarity - b.similarity;
    }
  }];
  propertiesKeys.forEach(function (propertyKey) {
    columns.push({
      title: propertyKey,
      dataIndex: propertyKey,
      key: propertyKey,
      width: 120,
      textWrap: 'word-break',
      ellipsis: true
    });
  });
  var onTableChange = function onTableChange(pagination, filters, sorter, extra) {
    if (extra.action === 'sort') {
      setSortOrder(sorter.order || false);
    }
  };
  var download = function download() {
    var fileName = formatFileName('similarity_result');
    exportCSV({
      data: resData,
      title: [$i18n.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.SerialNumber',
        dm: '序号'
      }), $i18n.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.NodeName',
        dm: '节点名称'
      }), $i18n.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.CosineSimilarity',
        dm: '余弦相似度'
      })].concat(propertiesKeys),
      titleForKey: ['index', 'label', 'similarity'].concat(propertiesKeys)
    }, fileName);
  };
  var activeItem = function activeItem(record) {
    clearActiveItem();
    var item = graph.findById(record.id);
    if (!item) return;
    graph.setItemState(item, 'active', true);
  };
  var clearActiveItem = function clearActiveItem() {
    var activateItems = graph.findAllByState('node', 'active').concat(graph.findAllByState('edge', 'active'));
    activateItems.forEach(function (item) {
      graph.setItemState(item, 'active', false);
    });
  };
  var maxSimilarNode = similarNodes[1];
  var minSimilarNode = similarNodes[similarNodes.length - 1];
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Tooltip, {
    title: $i18n.get({
      id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.DownloadCsv',
      dm: '下载 CSV'
    }),
    placement: "topRight"
  }, /*#__PURE__*/React.createElement(DownloadOutlined, {
    style: {
      float: 'right'
    },
    onClick: download
  })), /*#__PURE__*/React.createElement("div", {
    className: "nodes-similarity-table-wrapper"
  }, /*#__PURE__*/React.createElement("div", {
    className: "nodes-similarity-statistic"
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", null, $i18n.get({
    id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.MaximumValue',
    dm: '最大值:'
  })), /*#__PURE__*/React.createElement("span", {
    className: "nodes-similarity-statistic-value"
  }, formatSimilar(maxSimilarNode[similarityKey]), "\uFF08", maxSimilarNode === null || maxSimilarNode === void 0 ? void 0 : maxSimilarNode.label, "\uFF09")), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", null, $i18n.get({
    id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.MinimumValue',
    dm: '最小值:'
  })), /*#__PURE__*/React.createElement("span", {
    className: "nodes-similarity-statistic-value"
  }, formatSimilar(minSimilarNode[similarityKey]), "\uFF08", minSimilarNode === null || minSimilarNode === void 0 ? void 0 : minSimilarNode.label, "\uFF09"))), /*#__PURE__*/React.createElement(Table, {
    dataSource: resData,
    columns: columns,
    size: "small",
    showSorterTooltip: {
      title: $i18n.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.Sort',
        dm: '排序'
      })
    },
    scroll: {
      x: 200
    },
    onChange: onTableChange,
    onRow: function onRow(record) {
      return {
        onMouseEnter: function onMouseEnter() {
          return activeItem(record);
        },
        onMouseLeave: clearActiveItem
      };
    }
  })));
};
export default ClustersResultTable;