function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
import React from 'react';
import Util from '../utils';
import { ADD_EDGE_ID } from '../utils/graph';
import { createUuid } from '../utils/string';
var addEdge = Util.addEdge;
var AddRelation = /*#__PURE__*/function (_React$PureComponent) {
  function AddRelation() {
    var _this;
    _classCallCheck(this, AddRelation);
    _this = _callSuper(this, AddRelation, arguments);
    _this.dragging = null;
    _this.onOk = function () {
      if (!_this.dragging) return;
      var _this$props$options = _this.props.options,
        options = _this$props$options === void 0 ? {} : _this$props$options;
      var onOk = options.onOk;
      var model = _this.dragging.get('model');
      var source = model.source,
        target = model.target;
      onOk === null || onOk === void 0 ? void 0 : onOk({
        source: source,
        target: target
      });
    };
    _this.dragEdge = function (e) {
      var edge = e.item,
        canvasX = e.canvasX,
        canvasY = e.canvasY;
      if (edge.getID() !== ADD_EDGE_ID) return;
      var graph = _this.props.graph || _this.context.graph;
      graph.updateItem(edge, {
        target: {
          x: canvasX,
          y: canvasY
        }
      });
      _this.dragging = edge;
    };
    _this.drop = function (e) {
      var _a, _b;
      if (!_this.dragging) return;
      var item = e.item;
      if (!item || ((_a = item.isCanvas) === null || _a === void 0 ? void 0 : _a.call(item)) || ((_b = item.getType) === null || _b === void 0 ? void 0 : _b.call(item)) !== 'node') _this.cancelAdding();
      var graph = _this.props.graph || _this.context.graph;
      graph.updateItem(_this.dragging, {
        id: "edge-".concat(createUuid),
        target: item.getID(),
        type: 'graphin-line'
      });
      _this.onOk();
      _this.cancelAdding();
    };
    _this.cancelAdding = function () {
      var graph = _this.props.graph || _this.context.graph;
      _this.dragging = null;
      graph.removeItem(ADD_EDGE_ID);
    };
    _this.handleAddRelation = function () {
      var currentItem = _this.props.currentItem;
      var graph = _this.props.graph || _this.context.graph;
      var sourceId = currentItem === null || currentItem === void 0 ? void 0 : currentItem.get('id');
      addEdge(sourceId, graph);
    };
    return _this;
  }
  _inherits(AddRelation, _React$PureComponent);
  return _createClass(AddRelation, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var graph = this.props.graph || this.context.graph;
      graph.on('edge:drag', this.dragEdge);
      graph.on('drop', this.drop);
      graph.on('click', this.cancelAdding);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var graph = this.props.graph || this.context.graph;
      graph.off('edge:drag', this.dragEdge);
      graph.off('drop', this.drop);
      graph.off('click', this.cancelAdding);
    }
  }, {
    key: "render",
    value: function render() {
      var name = this.props.name;
      return /*#__PURE__*/React.createElement("a", {
        onClick: this.handleAddRelation
      }, name);
    }
  }]);
}(React.PureComponent);
AddRelation.defaultProps = {
  options: {
    onOk: function onOk() {}
  }
};
export default AddRelation;