function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React, { useCallback } from 'react';
import { Row, Col, Select, Input, Form } from 'antd';
import { DeleteOutlined } from '@ant-design/icons';
import Util from '../utils';
import { SPLITOR } from './registerMeta';
import { useEffect } from 'react';
import './index.less';
import $i18n from '../i18n';
var Option = Select.Option;
var debounce = Util.debounce;
var StyleConfigPropertyItem = function StyleConfigPropertyItem(_ref) {
  var color = _ref.color,
    pid = _ref.pid,
    properties = _ref.properties,
    visible = _ref.visible,
    form = _ref.form,
    disabled = _ref.disabled,
    _ref$configColor = _ref.configColor,
    configColor = _ref$configColor === void 0 ? true : _ref$configColor,
    deleteItem = _ref.deleteItem,
    _ref$openColorPanel = _ref.openColorPanel,
    openColorPanel = _ref$openColorPanel === void 0 ? function () {} : _ref$openColorPanel,
    _ref$emitPropertyConf = _ref.emitPropertyConfigChange,
    emitPropertyConfigChange = _ref$emitPropertyConf === void 0 ? function () {} : _ref$emitPropertyConf;
  var operators = ['>', '>=', '<=', '<', '=', '!=', 'like', 'unlike'];
  var onFromChange = function onFromChange() {
    var fieldValues = form.getFieldsValue();
    var validValues = Object.keys(fieldValues).filter(function (key) {
      var _a, _b;
      var value = fieldValues === null || fieldValues === void 0 ? void 0 : fieldValues[key];
      return ((_a = key.split(SPLITOR)) === null || _a === void 0 ? void 0 : _a[0]) === ((_b = pid.split(SPLITOR)) === null || _b === void 0 ? void 0 : _b[0]) && !!value;
    });
    if ((validValues === null || validValues === void 0 ? void 0 : validValues.length) >= 3) {
      emitPropertyConfigChange(fieldValues);
    }
  };
  var debounceChange = useCallback(debounce(onFromChange, 500), []);
  useEffect(function () {
    form.setFieldsValue(_defineProperty({}, "".concat(pid).concat(SPLITOR, "color"), color));
  }, []);
  return properties && visible ? ( /*#__PURE__*/React.createElement(Row, {
    className: "kg-style-config-property-item",
    key: pid,
    style: configColor ? {} : {
      width: '100%'
    }
  }, /*#__PURE__*/React.createElement(Col, {
    span: 8
  }, /*#__PURE__*/React.createElement(Form.Item, {
    rules: [{
      required: true,
      message: $i18n.get({
        id: 'gi-assets-algorithm.src.PatternMatch.StyleConfigPropertyItem.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "".concat(pid).concat(SPLITOR, "name")
  }, /*#__PURE__*/React.createElement(Select, {
    className: "kg-style-config-property-select",
    size: "small",
    placeholder: $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.StyleConfigPropertyItem.SelectProperties',
      dm: '选择属性'
    }),
    onChange: onFromChange,
    disabled: disabled
  }, properties.map(function (pKey) {
    return /*#__PURE__*/React.createElement(Option, {
      value: pKey,
      key: pKey
    }, pKey);
  })))), /*#__PURE__*/React.createElement(Col, {
    span: configColor ? 5 : 6,
    offset: 1
  }, /*#__PURE__*/React.createElement(Form.Item, {
    rules: [{
      required: true,
      message: $i18n.get({
        id: 'gi-assets-algorithm.src.PatternMatch.StyleConfigPropertyItem.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "".concat(pid).concat(SPLITOR, "operator")
  }, /*#__PURE__*/React.createElement(Select, {
    className: "kg-style-config-property-select",
    size: "small",
    onChange: onFromChange,
    dropdownMatchSelectWidth: false,
    disabled: disabled
  }, operators.map(function (operator) {
    return /*#__PURE__*/React.createElement(Option, {
      value: operator,
      key: operator
    }, operator);
  })))), /*#__PURE__*/React.createElement(Col, {
    span: configColor ? 5 : 6,
    offset: 1
  }, /*#__PURE__*/React.createElement(Form.Item, {
    rules: [{
      required: true,
      message: $i18n.get({
        id: 'gi-assets-algorithm.src.PatternMatch.StyleConfigPropertyItem.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "".concat(pid).concat(SPLITOR, "value")
  }, /*#__PURE__*/React.createElement(Input, {
    style: {
      width: '100%',
      height: '24px'
    },
    placeholder: $i18n.get({
      id: 'gi-assets-algorithm.src.PatternMatch.StyleConfigPropertyItem.EnterAttributeValues',
      dm: '输入属性值'
    }),
    onChange: debounceChange,
    disabled: disabled
  }))), configColor && ( /*#__PURE__*/React.createElement(Col, {
    span: 2,
    offset: 1
  }, color ? ( /*#__PURE__*/React.createElement("div", {
    className: "kg-style-config-property-item-color",
    style: {
      backgroundColor: color
    },
    onClick: function onClick(e) {
      return !disabled ? openColorPanel === null || openColorPanel === void 0 ? void 0 : openColorPanel(e, pid) : {};
    }
  })) : ( /*#__PURE__*/React.createElement("i", {
    className: "icon-ic_opacity iconfont kg-style-config-property-item-no-color",
    onClick: function onClick(e) {
      return openColorPanel(e, pid);
    }
  })))), /*#__PURE__*/React.createElement(Col, {
    span: 1,
    offset: configColor ? 0 : 1
  }, /*#__PURE__*/React.createElement(DeleteOutlined, {
    onClick: function onClick() {
      return deleteItem(pid);
    }
  })))) : ( /*#__PURE__*/React.createElement("div", {
    key: pid
  }));
};
export default StyleConfigPropertyItem;