import { IEdgeSchema, INodeSchema } from '@antv/gi-sdk';
import React from 'react';
import { TypeInfo } from './editDrawer';
import './index.less';
export type TypeProperties = {
    [type: string]: Set<string>;
};
interface Props {
    visible: boolean;
    patternInfo: {
        id: string;
        title: string;
        data: any;
    };
    setVisible: (visible: boolean) => void;
    savePattern: (id: string, data: any) => void;
    nodeProperties: TypeProperties;
    edgeProperties: TypeProperties;
    nodeTypes: TypeInfo[];
    edgeTypes: TypeInfo[];
    schemaEdgeMap: {
        [key: string]: IEdgeSchema;
    };
    schemaNodeMap: {
        [key: string]: INodeSchema;
    };
}
declare const PatternEditor: React.FC<Props>;
export default PatternEditor;
