import { Graph, Item } from '@antv/g6';
import type { GraphinData } from '@antv/graphin';
/**
 * 将图上下平移，y 坐标聚焦到画布中心
 * @param graph 图实例
 * @param focusNode 需要聚焦的节点 item
 * @param height 图的高度
 */
export declare const focusNodeY: (graph: any, focusNode: any, height: any, focusTo?: 'center' | 'top' | number) => void;
export declare const ADD_EDGE_ID = "ADD_EDGE_ID";
export declare const addEdge: (sourceId: string, graph: Graph) => void;
export declare function clearItemStates(graph: Graph, graphItem: Item, states: string[]): void;
export declare const clearItemsStates: (graph: Graph, items: Item[], clearStates: string[]) => void;
declare const _default: {
    scaleNodes: (graphData: GraphinData, value?: number) => {
        nodes: import("@antv/graphin").IUserNode[];
        edges: import("@antv/graphin").IUserEdge[];
    } | undefined;
    focusNodeY: (graph: any, focusNode: any, height: any, focusTo?: number | "center" | "top") => void;
    addEdge: (sourceId: string, graph: Graph) => void;
    exportGraphData: (data: any, fileName?: string) => string | undefined;
    clearItemsStates: (graph: Graph, items: Item[], clearStates: string[]) => void;
    clearItemStates: typeof clearItemStates;
};
export default _default;
