export declare const locale: {
    degree: string;
    'degree-tip': string;
    'page-rank': string;
    'page-rank-tip': string;
    'node-property': string;
    'node-property-tip': string;
    'edge-property': string;
    'edge-property-tip': string;
    'in-degree': string;
    'out-degree': string;
    ave: string;
    min: string;
    max: string;
    median: string;
    sort: string;
    'sort-tip': string;
    count: string;
    'count-tip': string;
    'positive-correlation': string;
    'positive-tip': string;
    'negative-correlation': string;
    'negative-tip': string;
};
export declare enum MappingWay {
    Positive = "positive",
    Negative = "negative"
}
export declare enum ITEM_STATE {
    Active = "active",
    Default = "default",
    Selected = "selected",
    Disable = "disable",
    Highlight = "highlight",
    Inactive = "inactive"
}
export interface PropertyContentProps {
    type: 'node' | 'edge';
    visible: boolean;
    form: any;
    properties: string[];
}
export interface NodeImportanceProps {
    visible?: boolean;
    onVisibleChange?: (visible: boolean) => void;
    hasDivider: boolean;
    color: string;
    controlledValues?: {
        algorithm: string;
        degreeIn: string;
        degreeOut: string;
        [formField: string]: unknown;
    };
    onOpen?: () => void;
}
declare const _default: () => {
    GI_CONTAINER_INDEX: {
        title: string;
        type: string;
        'x-decorator': string;
        'x-component': string;
        'x-component-props': {
            min: number;
            max: number;
        };
        default: number;
    };
    GIAC_CONTENT: {
        type: string;
        'x-decorator': string;
        'x-component': string;
        'x-component-props': {
            ghost: boolean;
            className: string;
        };
        properties: {
            GIAC_CONTENT: {
                type: string;
                'x-decorator': string;
                'x-component': string;
                'x-component-props': {
                    header: string;
                };
                properties: {
                    visible: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    disabled: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    isShowTitle: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-reactions': {
                            target: string;
                            fulfill: {
                                state: {
                                    visible: string;
                                };
                            };
                        }[];
                        default: boolean;
                    };
                    title: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    isShowIcon: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                        'x-reactions': {
                            target: string;
                            fulfill: {
                                state: {
                                    visible: string;
                                };
                            };
                        }[];
                    };
                    icon: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    isShowTooltip: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-reactions': {
                            target: string;
                            fulfill: {
                                state: {
                                    visible: string;
                                };
                            };
                        }[];
                        default: boolean;
                    };
                    tooltip: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    tooltipColor: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    tooltipPlacement: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            options: {
                                value: string;
                                label: string;
                            }[];
                        };
                        default: string;
                    };
                    hasDivider: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    height: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    isVertical: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    containerType: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        enum: {
                            label: string;
                            value: string;
                        }[];
                        default: string;
                    };
                    containerAnimate: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    containerDraggable: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: boolean;
                    };
                    dragHandle: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            options: {
                                value: string;
                                label: string;
                            }[];
                        };
                        default: string;
                    };
                    containerPlacement: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {
                            options: {
                                value: string;
                                label: string;
                            }[];
                        };
                        default: string;
                    };
                    offset: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: number[];
                    };
                    containerWidth: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    containerHeight: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        default: string;
                    };
                    contaienrMask: {
                        title: string;
                        type: string;
                        'x-decorator': string;
                        'x-component': string;
                        'x-component-props': {};
                        default: boolean;
                    };
                };
            };
        };
    };
};
export default _default;
