"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _giSdk = require("@antv/gi-sdk");
var _info = _interopRequireDefault(require("./info"));
var _giCommonComponents = require("@antv/gi-common-components");
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
var deepClone = _giSdk.extra.deepClone,
  GIAC_CONTENT_METAS = _giSdk.extra.GIAC_CONTENT_METAS;
var metas = deepClone(GIAC_CONTENT_METAS);
metas.GIAC_CONTENT.properties.GIAC_CONTENT.properties.title.default = _info.default.name;
metas.GIAC_CONTENT.properties.GIAC_CONTENT.properties.icon.default = _info.default.icon;
var nodeSelectionOption = [{
  value: _giCommonComponents.NodeSelectionMode.List,
  label: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodesSimilarity.registerMeta.ListAcquisition',
    dm: '列表获取'
  })
}, {
  value: _giCommonComponents.NodeSelectionMode.Canvas,
  label: _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodesSimilarity.registerMeta.CanvasPickup',
    dm: '画布拾取'
  })
}];
var nodeSelectionDefaultValue = nodeSelectionOption.map(function (item) {
  return item.value;
});
var registerMeta = function registerMeta(_ref) {
  var schemaData = _ref.schemaData;
  var nodeProperties = schemaData.nodes.reduce(function (acc, cur) {
    return Object.assign(Object.assign({}, acc), cur.properties);
  }, {});
  var options = Object.keys(nodeProperties).filter(function (key) {
    return nodeProperties[key] === 'string';
  }).map(function (e) {
    return {
      value: e,
      label: e
    };
  }).sort(function (a, b) {
    return a.value.localeCompare(b.value);
  });
  return Object.assign(Object.assign({
    nodeSelectionMode: {
      title: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.registerMeta.ObtainNodeMode',
        dm: '获取节点模式'
      }),
      type: 'array',
      enum: nodeSelectionOption,
      'x-decorator': 'FormItem',
      'x-component': 'Select',
      'x-component-props': {
        mode: 'multiple'
      },
      default: nodeSelectionDefaultValue
    },
    nodeLabel: {
      title: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.registerMeta.TagMapping',
        dm: '标签映射'
      }),
      type: 'string',
      'x-decorator': 'FormItem',
      'x-component': 'Select',
      enum: options,
      default: 'id',
      'x-component-props': {
        showSearch: true
      }
    }
  }, (0, _giCommonComponents.getNodeFormatOption)(options)), metas);
};
var _default = exports.default = registerMeta;