"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _giSdk = require("@antv/gi-sdk");
var _icons = require("@ant-design/icons");
var _antd = require("antd");
var _react = _interopRequireWildcard(require("react"));
var _csv = require("../utils/csv");
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; } // @ts-nocheck
var ClustersResultTable = function ClustersResultTable(_ref) {
  var similarNodes = _ref.similarNodes,
    _ref$similarityKey = _ref.similarityKey,
    similarityKey = _ref$similarityKey === void 0 ? 'similarity' : _ref$similarityKey,
    topReset = _ref.topReset;
  var _useContext = (0, _giSdk.useContext)(),
    graph = _useContext.graph;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    sortOrder = _useState2[0],
    setSortOrder = _useState2[1];
  (0, _react.useEffect)(function () {
    setSortOrder(false);
  }, [topReset]);
  var formatSimilar = function formatSimilar(value) {
    return Number("".concat(value).slice(0, 7));
  };
  var propertiesKeys = [];
  var resData = [];
  similarNodes === null || similarNodes === void 0 ? void 0 : similarNodes.forEach(function (node, index) {
    if (!node.properties) {
      return;
    }
    propertiesKeys.push('id');
    propertiesKeys = propertiesKeys.concat(Object.keys(node.properties));
    resData.push(Object.assign(Object.assign({}, node.properties), {
      index: index,
      label: node.label,
      similarity: node[similarityKey] ? formatSimilar(node[similarityKey]) : '-',
      id: node.id
    }));
  });
  propertiesKeys = Array.from(new Set(propertiesKeys));
  var columns = [{
    title: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.SerialNumber',
      dm: '序号'
    }),
    dataIndex: 'index',
    key: 'index',
    width: 60,
    fixed: 'left'
  }, {
    title: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.NodeName',
      dm: '节点名称'
    }),
    dataIndex: 'label',
    key: 'label',
    textWrap: 'word-break',
    ellipsis: true,
    fixed: 'left',
    width: 100
  }, {
    title: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.NodeId',
      dm: '节点 ID'
    }),
    dataIndex: 'id',
    key: 'id',
    textWrap: 'word-break',
    ellipsis: true,
    // fixed: 'left',
    width: 100
  }, {
    title: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.CosineSimilarity',
      dm: '余弦相似度'
    }),
    dataIndex: 'similarity',
    key: 'similarity',
    textWrap: 'word-break',
    // fixed: 'left',
    width: 120,
    sortOrder: sortOrder,
    sorter: function sorter(a, b) {
      return a.similarity - b.similarity;
    }
  }];
  propertiesKeys.forEach(function (propertyKey) {
    columns.push({
      title: propertyKey,
      dataIndex: propertyKey,
      key: propertyKey,
      width: 120,
      textWrap: 'word-break',
      ellipsis: true
    });
  });
  var onTableChange = function onTableChange(pagination, filters, sorter, extra) {
    if (extra.action === 'sort') {
      setSortOrder(sorter.order || false);
    }
  };
  var download = function download() {
    var fileName = (0, _csv.formatFileName)('similarity_result');
    (0, _csv.exportCSV)({
      data: resData,
      title: [_i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.SerialNumber',
        dm: '序号'
      }), _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.NodeName',
        dm: '节点名称'
      }), _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.CosineSimilarity',
        dm: '余弦相似度'
      })].concat(propertiesKeys),
      titleForKey: ['index', 'label', 'similarity'].concat(propertiesKeys)
    }, fileName);
  };
  var activeItem = function activeItem(record) {
    clearActiveItem();
    var item = graph.findById(record.id);
    if (!item) return;
    graph.setItemState(item, 'active', true);
  };
  var clearActiveItem = function clearActiveItem() {
    var activateItems = graph.findAllByState('node', 'active').concat(graph.findAllByState('edge', 'active'));
    activateItems.forEach(function (item) {
      graph.setItemState(item, 'active', false);
    });
  };
  var maxSimilarNode = similarNodes[1];
  var minSimilarNode = similarNodes[similarNodes.length - 1];
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
    title: _i18n.default.get({
      id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.DownloadCsv',
      dm: '下载 CSV'
    }),
    placement: "topRight"
  }, /*#__PURE__*/_react.default.createElement(_icons.DownloadOutlined, {
    style: {
      float: 'right'
    },
    onClick: download
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "nodes-similarity-table-wrapper"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "nodes-similarity-statistic"
  }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("span", null, _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.MaximumValue',
    dm: '最大值:'
  })), /*#__PURE__*/_react.default.createElement("span", {
    className: "nodes-similarity-statistic-value"
  }, formatSimilar(maxSimilarNode[similarityKey]), "\uFF08", maxSimilarNode === null || maxSimilarNode === void 0 ? void 0 : maxSimilarNode.label, "\uFF09")), /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("span", null, _i18n.default.get({
    id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.MinimumValue',
    dm: '最小值:'
  })), /*#__PURE__*/_react.default.createElement("span", {
    className: "nodes-similarity-statistic-value"
  }, formatSimilar(minSimilarNode[similarityKey]), "\uFF08", minSimilarNode === null || minSimilarNode === void 0 ? void 0 : minSimilarNode.label, "\uFF09"))), /*#__PURE__*/_react.default.createElement(_antd.Table, {
    dataSource: resData,
    columns: columns,
    size: "small",
    showSorterTooltip: {
      title: _i18n.default.get({
        id: 'gi-assets-algorithm.src.NodesSimilarity.resultTable.Sort',
        dm: '排序'
      })
    },
    scroll: {
      x: 200
    },
    onChange: onTableChange,
    onRow: function onRow(record) {
      return {
        onMouseEnter: function onMouseEnter() {
          return activeItem(record);
        },
        onMouseLeave: clearActiveItem
      };
    }
  })));
};
var _default = exports.default = ClustersResultTable;