"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _antd = require("antd");
var _icons = require("@ant-design/icons");
var _utils = _interopRequireDefault(require("../utils"));
var _registerMeta = require("./registerMeta");
require("./index.less");
var _i18n = _interopRequireDefault(require("../i18n"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var Option = _antd.Select.Option;
var debounce = _utils.default.debounce;
var StyleConfigPropertyItem = function StyleConfigPropertyItem(_ref) {
  var color = _ref.color,
    pid = _ref.pid,
    properties = _ref.properties,
    visible = _ref.visible,
    form = _ref.form,
    disabled = _ref.disabled,
    _ref$configColor = _ref.configColor,
    configColor = _ref$configColor === void 0 ? true : _ref$configColor,
    deleteItem = _ref.deleteItem,
    _ref$openColorPanel = _ref.openColorPanel,
    openColorPanel = _ref$openColorPanel === void 0 ? function () {} : _ref$openColorPanel,
    _ref$emitPropertyConf = _ref.emitPropertyConfigChange,
    emitPropertyConfigChange = _ref$emitPropertyConf === void 0 ? function () {} : _ref$emitPropertyConf;
  var operators = ['>', '>=', '<=', '<', '=', '!=', 'like', 'unlike'];
  var onFromChange = function onFromChange() {
    var fieldValues = form.getFieldsValue();
    var validValues = Object.keys(fieldValues).filter(function (key) {
      var _a, _b;
      var value = fieldValues === null || fieldValues === void 0 ? void 0 : fieldValues[key];
      return ((_a = key.split(_registerMeta.SPLITOR)) === null || _a === void 0 ? void 0 : _a[0]) === ((_b = pid.split(_registerMeta.SPLITOR)) === null || _b === void 0 ? void 0 : _b[0]) && !!value;
    });
    if ((validValues === null || validValues === void 0 ? void 0 : validValues.length) >= 3) {
      emitPropertyConfigChange(fieldValues);
    }
  };
  var debounceChange = (0, _react.useCallback)(debounce(onFromChange, 500), []);
  (0, _react.useEffect)(function () {
    form.setFieldsValue(_defineProperty({}, "".concat(pid).concat(_registerMeta.SPLITOR, "color"), color));
  }, []);
  return properties && visible ? ( /*#__PURE__*/_react.default.createElement(_antd.Row, {
    className: "kg-style-config-property-item",
    key: pid,
    style: configColor ? {} : {
      width: '100%'
    }
  }, /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 8
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    rules: [{
      required: true,
      message: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.StyleConfigPropertyItem.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "".concat(pid).concat(_registerMeta.SPLITOR, "name")
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    className: "kg-style-config-property-select",
    size: "small",
    placeholder: _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatch.StyleConfigPropertyItem.SelectProperties',
      dm: '选择属性'
    }),
    onChange: onFromChange,
    disabled: disabled
  }, properties.map(function (pKey) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      value: pKey,
      key: pKey
    }, pKey);
  })))), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: configColor ? 5 : 6,
    offset: 1
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    rules: [{
      required: true,
      message: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.StyleConfigPropertyItem.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "".concat(pid).concat(_registerMeta.SPLITOR, "operator")
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    className: "kg-style-config-property-select",
    size: "small",
    onChange: onFromChange,
    dropdownMatchSelectWidth: false,
    disabled: disabled
  }, operators.map(function (operator) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      value: operator,
      key: operator
    }, operator);
  })))), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: configColor ? 5 : 6,
    offset: 1
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    rules: [{
      required: true,
      message: _i18n.default.get({
        id: 'gi-assets-algorithm.src.PatternMatch.StyleConfigPropertyItem.CannotBeEmpty',
        dm: '不可为空'
      })
    }],
    name: "".concat(pid).concat(_registerMeta.SPLITOR, "value")
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    style: {
      width: '100%',
      height: '24px'
    },
    placeholder: _i18n.default.get({
      id: 'gi-assets-algorithm.src.PatternMatch.StyleConfigPropertyItem.EnterAttributeValues',
      dm: '输入属性值'
    }),
    onChange: debounceChange,
    disabled: disabled
  }))), configColor && ( /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 2,
    offset: 1
  }, color ? ( /*#__PURE__*/_react.default.createElement("div", {
    className: "kg-style-config-property-item-color",
    style: {
      backgroundColor: color
    },
    onClick: function onClick(e) {
      return !disabled ? openColorPanel === null || openColorPanel === void 0 ? void 0 : openColorPanel(e, pid) : {};
    }
  })) : ( /*#__PURE__*/_react.default.createElement("i", {
    className: "icon-ic_opacity iconfont kg-style-config-property-item-no-color",
    onClick: function onClick(e) {
      return openColorPanel(e, pid);
    }
  })))), /*#__PURE__*/_react.default.createElement(_antd.Col, {
    span: 1,
    offset: configColor ? 0 : 1
  }, /*#__PURE__*/_react.default.createElement(_icons.DeleteOutlined, {
    onClick: function onClick() {
      return deleteItem(pid);
    }
  })))) : ( /*#__PURE__*/_react.default.createElement("div", {
    key: pid
  }));
};
var _default = exports.default = StyleConfigPropertyItem;